/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.45 Revision 1.61
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.45 2006/09/22 22:25:06 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $
4# 4#
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# Author: Diego Pettenò <flameeyes@gentoo.org>
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# Enhancements: Martin Schlemmer <azarah@gentoo.org>
7# 7#
8# This eclass is for handling autotooled software packages that 8# This eclass is for handling autotooled software packages that
10# 10#
11# NB: If you add anything, please comment it! 11# NB: If you add anything, please comment it!
12 12
13inherit eutils libtool 13inherit eutils libtool
14 14
15[[ ${WANT_AUTOMAKE} == "latest" ]] && export WANT_AUTOMAKE=1.9
16[[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
17
18_automake_atom="sys-devel/automake" 15_automake_atom="sys-devel/automake"
19_autoconf_atom="sys-devel/autoconf" 16_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;;
20[[ -n ${WANT_AUTOMAKE} ]] && _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" 21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac
23fi
24
21if [[ -n ${WANT_AUTOCONF} ]] ; then 25if [[ -n ${WANT_AUTOCONF} ]] ; then
22 case ${WANT_AUTOCONF} in 26 case ${WANT_AUTOCONF} in
23 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
24 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;;
25 esac 29 esac
26fi 30fi
27DEPEND="${_automake_atom} 31DEPEND="${_automake_atom}
28 ${_autoconf_atom} 32 ${_autoconf_atom}
29 sys-devel/libtool" 33 sys-devel/libtool"
34RDEPEND=""
30unset _automake_atom _autoconf_atom 35unset _automake_atom _autoconf_atom
31 36
32# Variables: 37# Variables:
33# 38#
34# AT_M4DIR - Additional director(y|ies) aclocal should search 39# AT_M4DIR - Additional director(y|ies) aclocal should search
35# AM_OPTS - Additional options to pass to automake during 40# AM_OPTS - Additional options to pass to automake during
36# eautoreconf call. 41# eautoreconf call.
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with
44# particular options
37 45
38# Functions: 46# Functions:
39# 47#
40# eautoreconf() - Should do a full autoreconf - normally what most people 48# eautoreconf() - Should do a full autoreconf - normally what most people
41# will be interested in. Also should handle additional 49# will be interested in. Also should handle additional
109 ;; 117 ;;
110 esac 118 esac
111 done 119 done
112 fi 120 fi
113 121
122 autotools_set_versions
114 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
115 autotools_run_tool aclocal "$@" ${aclocal_opts} 124 autotools_run_tool aclocal "$@" ${aclocal_opts}
116} 125}
117 126
118_elibtoolize() { 127_elibtoolize() {
134} 143}
135 144
136eautoheader() { 145eautoheader() {
137 # Check if we should run autoheader 146 # Check if we should run autoheader
138 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
148 autotools_set_versions
139 autotools_run_tool autoheader "$@" 149 NO_FAIL=1 autotools_run_tool autoheader "$@"
140} 150}
141 151
142eautoconf() { 152eautoconf() {
143 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
144 echo 154 echo
145 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!"
146 echo 156 echo
147 die "No configure.{ac,in} present!" 157 die "No configure.{ac,in} present!"
148 fi 158 fi
149 159
160 autotools_set_versions
150 autotools_run_tool autoconf "$@" 161 autotools_run_tool autoconf "$@"
151} 162}
152 163
153eautomake() { 164eautomake() {
154 local extra_opts 165 local extra_opts
155 166
156 [[ -f Makefile.am ]] || return 0 167 [[ -f Makefile.am ]] || return 0
157 168
158 if [[ -n ${WANT_AUTOMAKE} ]]; then 169 autotools_set_versions
159 export WANT_AUTOMAKE # let the automake wrapper pick it up
160 einfo "Required automake ${WANT_AUTOMAKE}. Using $(automake --version | head -n 1)."
161 fi
162
163 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then
164 local used_automake 171 local used_automake
165 local installed_automake 172 local installed_automake
166 173
167 installed_automake=$(automake --version | head -n 1 | \ 174 installed_automake=$(automake --version | head -n 1 | \
182 189
183 # --force-missing seems not to be recognized by some flavours of automake 190 # --force-missing seems not to be recognized by some flavours of automake
184 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
185} 192}
186 193
194autotools_set_versions() {
195 [[ -n ${autotools_version_sets} ]] && return 0
187 196
197 if [[ -n ${WANT_AUTOCONF} ]]; then
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5"
199 export WANT_AUTOCONF
200 einfo "Requested autoconf ${WANT_AUTOCONF}"
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)"
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)"
203 else
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/"
205 fi
206
207 if [[ -n ${WANT_AUTOMAKE} ]]; then
208 local latest_automake
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
210 latest_automake="latest: "
211 for amver in 1.10 1.9 1.8 1.7 1.6; do
212 WANT_AUTOMAKE="${amver}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break
214 done
215 fi
216 export WANT_AUTOMAKE
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225}
188 226
189# Internal function to run an autotools' tool 227# Internal function to run an autotools' tool
190autotools_run_tool() { 228autotools_run_tool() {
191 local STDERR_TARGET="${T}/$$.out" 229 local STDERR_TARGET="${T}/$$.out"
192 local PATCH_TARGET="${T}/$$.patch"
193 local ris 230 local ris
194 231
195 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
196 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
197 234
198 ebegin "Running $@" 235 ebegin "Running $@"
199 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1
200 ris=$? 237 ris=$?
201 eend ${ris} 238 eend ${ris}
202 239
203 if [[ ${ris} != 0 ]]; then 240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
204 echo 241 echo
205 eerror "Failed Running $1 !" 242 eerror "Failed Running $1 !"
206 eerror 243 eerror
207 eerror "Include in your bugreport the contents of:" 244 eerror "Include in your bugreport the contents of:"
208 eerror 245 eerror

Legend:
Removed from v.1.45  
changed lines
  Added in v.1.61

  ViewVC Help
Powered by ViewVC 1.1.20